Whamcloud - gitweb
LU-8726 osd-ldiskfs: bypass read for benchmarking
[fs/lustre-release.git] / lustre / tests / sanity.sh
index 085a3f4..b389e68 100755 (executable)
@@ -13,8 +13,8 @@ ALWAYS_EXCEPT="                42a  42b  42c  42d  45   68b   $SANITY_EXCEPT"
 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
 
 # with LOD/OSP landing
-# bug number for skipped tests: LU-2036 LU-8139
-ALWAYS_EXCEPT="                 76     101g    $ALWAYS_EXCEPT"
+# bug number for skipped tests: LU-2036 LU-8139 LU-8411
+ALWAYS_EXCEPT="                 76     101g    407 $ALWAYS_EXCEPT"
 
 is_sles11()                                            # LU-4341
 {
@@ -81,8 +81,8 @@ init_logging
 if [ $(facet_fstype $SINGLEMDS) = "zfs" ]; then
        # bug number for skipped test: LU-4536 LU-1957
        ALWAYS_EXCEPT="$ALWAYS_EXCEPT  65ic    180"
-       #                                               4   13    (min)"
-       [ "$SLOW" = "no" ] && EXCEPT_SLOW="$EXCEPT_SLOW 51b 51ba"
+       #                                               13    (min)"
+       [ "$SLOW" = "no" ] && EXCEPT_SLOW="$EXCEPT_SLOW 51b"
 fi
 
 FAIL_ON_ERROR=false
@@ -264,6 +264,21 @@ test_6g() {
        test_mkdir $DIR/$tdir/d/subdir || error "mkdir $tdir/d/subdir failed"
        $CHECKSTAT -g \#$RUNAS_GID $DIR/$tdir/d/subdir ||
                error "$tdir/d/subdir should be GID $RUNAS_GID"
+       if [[ $MDSCOUNT -gt 1 ]]; then
+               # check remote dir sgid inherite
+               $LFS mkdir -i 0 $DIR/$tdir.local ||
+                       error "mkdir $tdir.local failed"
+               chmod g+s $DIR/$tdir.local ||
+                       error "chmod $tdir.local failed"
+               chgrp $RUNAS_GID $DIR/$tdir.local ||
+                       error "chgrp $tdir.local failed"
+               $LFS mkdir -i 1 $DIR/$tdir.local/$tdir.remote ||
+                       error "mkdir $tdir.remote failed"
+               $CHECKSTAT -g \#$RUNAS_GID $DIR/$tdir.local/$tdir.remote ||
+                       error "$tdir.remote should be owned by $UID.$RUNAS_ID"
+               $CHECKSTAT -p 02755 $DIR/$tdir.local/$tdir.remote ||
+                       error "$tdir.remote should be mode 02755"
+       fi
 }
 run_test 6g "Is new dir in sgid dir inheriting group?"
 
@@ -1650,7 +1665,7 @@ test_27u() { # bug 4900
        createmany -o $DIR/$tdir/t- 1000
        do_nodes $list $LCTL set_param fail_loc=0
 
-       TLOG=$DIR/$tfile.getstripe
+       TLOG=$TMP/$tfile.getstripe
        $GETSTRIPE $DIR/$tdir > $TLOG
        OBJS=$(awk -vobj=0 '($1 == 0) { obj += 1 } END { print obj; }' $TLOG)
        unlinkmany $DIR/$tdir/t- 1000
@@ -2411,10 +2426,10 @@ run_test 31p "remove of open striped directory"
 cleanup_test32_mount() {
        local rc=0
        trap 0
-       local loopdev=$(losetup -a | grep $EXT2_DEV | sed -ne 's/:.*$/p')
+       local loopdev=$(losetup -a | grep $EXT2_DEV | sed -ne 's/:.*$//p')
        $UMOUNT $DIR/$tdir/ext2-mountpoint || rc=$?
        losetup -d $loopdev || true
-       rm -rf $DIR/$tdir/ext2-mountpoint
+       rm -rf $DIR/$tdir
        return $rc
 }
 
@@ -2598,59 +2613,49 @@ test_32o() {
 run_test 32o "stat d32o/symlink->tmp/symlink->lustre-root/$tfile"
 
 test_32p() {
-    log 32p_1
+       log 32p_1
        rm -fr $DIR/d32p
-    log 32p_2
+       log 32p_2
        rm -f $DIR/$tfile
-    log 32p_3
+       log 32p_3
        touch $DIR/$tfile
-    log 32p_4
+       log 32p_4
        test_mkdir -p $DIR/d32p/tmp
-    log 32p_5
+       log 32p_5
        TMP_DIR=$DIR/d32p/tmp
-    log 32p_6
+       log 32p_6
        ln -s $DIR/$tfile $TMP_DIR/symlink12
-    log 32p_7
+       log 32p_7
        ln -s $TMP_DIR/symlink12 $TMP_DIR/../symlink02
-    log 32p_8
+       log 32p_8
        cat $DIR/d32p/tmp/symlink12 || error
-    log 32p_9
+       log 32p_9
        cat $DIR/d32p/symlink02 || error
-    log 32p_10
+       log 32p_10
 }
 run_test 32p "open d32p/symlink->tmp/symlink->lustre-root/$tfile"
 
-cleanup_testdir_mount() {
-       local rc=0
-       trap 0
-       local loopdev=$(losetup -a | grep $EXT2_DEV | sed -ne 's/:.*$/p')
-       $UMOUNT $DIR/$tdir || rc=$?
-       losetup -d $loopdev || true
-       rm -rf $DIR/$tdir
-       return $rc
-}
-
 test_32q() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        [ -e $DIR/$tdir ] && rm -fr $DIR/$tdir
-       trap cleanup_testdir_mount EXIT
-       test_mkdir -p $DIR/$tdir
-        touch $DIR/$tdir/under_the_mount
-       mount -t ext2 -o loop $EXT2_DEV $DIR/$tdir
-       ls $DIR/$tdir | grep "\<under_the_mount\>" && error
-       cleanup_testdir_mount
+       trap cleanup_test32_mount EXIT
+       test_mkdir -p $DIR/$tdir/ext2-mountpoint
+       touch $DIR/$tdir/ext2-mountpoint/under_the_mount
+       mount -t ext2 -o loop $EXT2_DEV $DIR/$tdir/ext2-mountpoint
+       ls $DIR/$tdir/ext2-mountpoint | grep "\<under_the_mount\>" && error
+       cleanup_test32_mount
 }
 run_test 32q "stat follows mountpoints in Lustre (should return error)"
 
 test_32r() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        [ -e $DIR/$tdir ] && rm -fr $DIR/$tdir
-       trap cleanup_testdir_mount EXIT
-       test_mkdir -p $DIR/$tdir
-        touch $DIR/$tdir/under_the_mount
-       mount -t ext2 -o loop $EXT2_DEV $DIR/$tdir
-       ls $DIR/$tdir | grep -q under_the_mount && error || true
-       cleanup_testdir_mount
+       trap cleanup_test32_mount EXIT
+       test_mkdir -p $DIR/$tdir/ext2-mountpoint
+       touch $DIR/$tdir/ext2-mountpoint/under_the_mount
+       mount -t ext2 -o loop $EXT2_DEV $DIR/$tdir/ext2-mountpoint
+       ls $DIR/$tdir/ext2-mountpoint | grep -q under_the_mount && error || true
+       cleanup_test32_mount
 }
 run_test 32r "opendir follows mountpoints in Lustre (should return error)"
 
@@ -2850,6 +2855,15 @@ test_33f() {
 }
 run_test 33f "nonroot user can create, access, and remove a striped directory"
 
+test_33g() {
+       mkdir -p $DIR/$tdir/dir2
+
+       local err=$($RUNAS mkdir $DIR/$tdir/dir2 2>&1)
+       echo $err
+       [[ $err =~ "exists" ]] || error "Not exists error"
+}
+run_test 33g "nonroot user create already existing root created file"
+
 TEST_34_SIZE=${TEST_34_SIZE:-2000000000000}
 test_34a() {
        rm -f $DIR/f34
@@ -3103,7 +3117,7 @@ test_38() {
 }
 run_test 38 "open a regular file with O_DIRECTORY should return -ENOTDIR ==="
 
-test_39() {
+test_39a() { # was test_39
        touch $DIR/$tfile
        touch $DIR/${tfile}2
 #      ls -l  $DIR/$tfile $DIR/${tfile}2
@@ -3121,7 +3135,7 @@ test_39() {
                error "O_TRUNC didn't change timestamps"
        fi
 }
-run_test 39 "mtime changed on create ==========================="
+run_test 39a "mtime changed on create ==========================="
 
 test_39b() {
        test_mkdir -p -c1 $DIR/$tdir
@@ -3783,7 +3797,7 @@ test_42e() { # bug22074
 }
 run_test 42e "verify sub-RPC writes are not done synchronously"
 
-test_43() {
+test_43A() { # was test_43
        test_mkdir -p $DIR/$tdir
        cp -p /bin/ls $DIR/$tdir/$tfile
        $MULTIOP $DIR/$tdir/$tfile Ow_c &
@@ -3794,7 +3808,7 @@ test_43() {
        $DIR/$tdir/$tfile && error || true
        kill -USR1 $pid
 }
-run_test 43 "execution of file opened for write should return -ETXTBSY"
+run_test 43A "execution of file opened for write should return -ETXTBSY"
 
 test_43a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
@@ -3835,12 +3849,12 @@ test_43c() {
 }
 run_test 43c "md5sum of copy into lustre========================"
 
-test_44() {
+test_44A() { # was test_44
        [[ $OSTCOUNT -lt 2 ]] && skip_env "skipping 2-stripe test" && return
        dd if=/dev/zero of=$DIR/f1 bs=4k count=1 seek=1023
        dd if=$DIR/f1 bs=4k count=1 > /dev/null
 }
-run_test 44 "zero length read from a sparse stripe ============="
+run_test 44A "zero length read from a sparse stripe ============="
 
 test_44a() {
        local nstripe=$($LCTL lov_getconfig $DIR | grep default_stripe_count: |
@@ -4097,6 +4111,12 @@ test_51a() {     # was test_51
 }
 run_test 51a "special situations: split htree with empty entry =="
 
+cleanup_print_lfs_df () {
+       trap 0
+       $LFS df
+       $LFS df -i
+}
+
 test_51b() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        local dir=$DIR/$tdir
@@ -4118,10 +4138,12 @@ test_51b() {
 
        # need to check free space for the directories as well
        local blkfree=$(lctl get_param -n mdc.$FSNAME-MDT$mdtidx*.kbytesavail)
-       numfree=$((blkfree / 4))
+       numfree=$(( blkfree / $(fs_inode_ksize) ))
        [[ $numfree -lt $nrdirs ]] && skip "not enough blocks ($numfree)" &&
                return
 
+       trap cleanup_print_lfsdf EXIT
+
        # create files
        createmany -d $dir/d $nrdirs ||
                error "failed to create $nrdirs subdirs in MDT$mdtidx:$dir"
@@ -4133,6 +4155,9 @@ test_51b() {
        local left=100
        local delete=$((nrdirs - left))
 
+       $LFS df
+       $LFS df -i
+
        # for ldiskfs the nlink count should be 1, but this is OSD specific
        # and so this is listed for informational purposes only
        echo "nlink before: $(stat -c %h $dir), created before: $nrdirs"
@@ -4151,6 +4176,8 @@ test_51b() {
        local after=$(stat -c %h $dir)
        [[ $after -gt 2 ]] && error "nlink after: $after > 2" ||
                echo "nlink after: $after"
+
+       cleanup_print_lfs_df
 }
 run_test 51b "exceed 64k subdirectory nlink limit on create, verify unlink"
 
@@ -4423,30 +4450,47 @@ test_56a() {    # was test_56
                error "$GETSTRIPE $DIR/$tdir: found $FILENUM, not $NUMFILES"
        echo "$GETSTRIPE --recursive passed."
 
-        # test lfs getstripe with file instead of dir
+       # test lfs getstripe with file instead of dir
        FILENUM=$($GETSTRIPE $DIR/$tdir/file1 | grep -c obdidx)
        [[ $FILENUM -eq 1 ]] ||
                error "$GETSTRIPE $DIR/$tdir/file1: found $FILENUM, not 1"
        echo "$GETSTRIPE file1 passed."
 
-        #test lfs getstripe with --verbose
+       #test lfs getstripe with --verbose
        [[ $($GETSTRIPE --verbose $DIR/$tdir |
                grep -c lmm_magic) -eq $NUMFILES ]] ||
                error "$GETSTRIPE --verbose $DIR/$tdir: want $NUMFILES"
        [[ $($GETSTRIPE $DIR/$tdir | grep -c lmm_magic) -eq 0 ]] ||
-               rror "$GETSTRIPE $DIR/$tdir: showed lmm_magic"
+               error "$GETSTRIPE $DIR/$tdir: showed lmm_magic"
+
+       #test lfs getstripe with -v prints lmm_fid
+       [[ $($GETSTRIPE -v $DIR/$tdir | grep -c lmm_fid) -eq $NUMFILES ]] ||
+               error "$GETSTRIPE -v $DIR/$tdir: want $NUMFILES lmm_fid: lines"
+       [[ $($GETSTRIPE $DIR/$tdir | grep -c lmm_fid) -eq 0 ]] ||
+               error "$GETSTRIPE $DIR/$tdir: showed lmm_fid"
        echo "$GETSTRIPE --verbose passed."
 
-        #test lfs getstripe with --obd
-        $GETSTRIPE --obd wrong_uuid $DIR/$tdir 2>&1 |
+       #check for FID information
+       local fid1=$($GETSTRIPE --fid $DIR/$tdir/file1)
+       local fid2=$($GETSTRIPE --verbose $DIR/$tdir/file1 |
+                      awk '/lmm_fid: / { print $2 }')
+       local fid3=$($LFS path2fid $DIR/$tdir/file1)
+       [ "$fid1" != "$fid2" ] &&
+               error "getstripe --fid $fid1 != getstripe --verbose $fid2"
+       [ "$fid1" != "$fid3" ] &&
+               error "getstripe --fid $fid1 != lfs path2fid $fid3"
+       echo "$GETSTRIPE --fid passed."
+
+       #test lfs getstripe with --obd
+       $GETSTRIPE --obd wrong_uuid $DIR/$tdir 2>&1 |
                grep -q "unknown obduuid" ||
                error "$GETSTRIPE --obd wrong_uuid should return error message"
 
        [[ $OSTCOUNT -lt 2 ]] &&
-                skip_env "skipping other $GETSTRIPE --obd test" && return
+               skip_env "skipping other $GETSTRIPE --obd test" && return
 
-        OSTIDX=1
-        OBDUUID=$(ostuuid_from_index $OSTIDX)
+       OSTIDX=1
+       OBDUUID=$(ostuuid_from_index $OSTIDX)
        FILENUM=$($GETSTRIPE -ir $DIR/$tdir | grep "^$OSTIDX\$" | wc -l)
        FOUND=$($GETSTRIPE -r --obd $OBDUUID $DIR/$tdir | grep obdidx | wc -l)
        [[ $FOUND -eq $FILENUM ]] ||
@@ -4792,7 +4836,7 @@ run_test 56s "check lfs find -stripe-count works"
 
 test_56t() { # LU-611
        TDIR=$DIR/${tdir}t
-       setup_56 $NUMFILES $NUMDIRS "-s 512k"
+       setup_56 $NUMFILES $NUMDIRS "--stripe-size 512k"
 
        $SETSTRIPE -S 256k $TDIR/$tfile.{0,1,2,3}
 
@@ -5692,10 +5736,6 @@ cleanup_68() {
                rm -f $LLOOP
                unset LLOOP
        fi
-       if [ ! -z "$LLITELOOPLOAD" ]; then
-               rmmod llite_lloop
-               unset LLITELOOPLOAD
-       fi
        rm -f $DIR/f68*
 }
 
@@ -5707,74 +5747,6 @@ swap_used() {
        swapon -s | awk '($1 == "'$1'") { print $4 }'
 }
 
-# test case for lloop driver, basic function
-test_68a() {
-       [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-       [ "$UID" != 0 ] && skip_env "must run as root" && return
-       llite_lloop_enabled || \
-               { skip_env "llite_lloop module disabled" && return; }
-
-       trap cleanup_68 EXIT
-
-       if ! module_loaded llite_lloop; then
-               if load_module llite/llite_lloop; then
-                       LLITELOOPLOAD=yes
-               else
-                       skip_env "can't find module llite_lloop"
-                       return
-               fi
-       fi
-
-       LLOOP=$TMP/lloop.`date +%s`.`date +%N`
-       dd if=/dev/zero of=$DIR/f68a bs=4k count=1024
-       $LCTL blockdev_attach $DIR/f68a $LLOOP || error "attach failed"
-
-       directio rdwr $LLOOP 0 1024 4096 || error "direct write failed"
-       directio rdwr $LLOOP 0 1025 4096 && error "direct write should fail"
-
-       cleanup_68
-}
-run_test 68a "lloop driver - basic test ========================"
-
-# excercise swapping to lustre by adding a high priority swapfile entry
-# and then consuming memory until it is used.
-test_68b() {  # was test_68
-       [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
-       [ "$UID" != 0 ] && skip_env "must run as root" && return
-       lctl get_param -n devices | grep -q obdfilter && \
-               skip "local OST" && return
-
-       grep -q llite_lloop /proc/modules
-       [ $? -ne 0 ] && skip "can't find module llite_lloop" && return
-
-       [ -z "`$LCTL list_nids | grep -v tcp`" ] && \
-               skip "can't reliably test swap with TCP" && return
-
-       MEMTOTAL=`meminfo MemTotal`
-       NR_BLOCKS=$((MEMTOTAL>>8))
-       [[ $NR_BLOCKS -le 2048 ]] && NR_BLOCKS=2048
-
-       LLOOP=$TMP/lloop.`date +%s`.`date +%N`
-       dd if=/dev/zero of=$DIR/f68b bs=64k seek=$NR_BLOCKS count=1
-       mkswap $DIR/f68b
-
-       $LCTL blockdev_attach $DIR/f68b $LLOOP || error "attach failed"
-
-       trap cleanup_68 EXIT
-
-       swapon -p 32767 $LLOOP || error "swapon $LLOOP failed"
-
-       echo "before: `swapon -s | grep $LLOOP`"
-       $MEMHOG $MEMTOTAL || error "error allocating $MEMTOTAL kB"
-       echo "after: `swapon -s | grep $LLOOP`"
-       SWAPUSED=`swap_used $LLOOP`
-
-       cleanup_68
-
-       [ $SWAPUSED -eq 0 ] && echo "no swap used???" || true
-}
-run_test 68b "support swapping to Lustre ========================"
-
 # bug5265, obdfilter oa2dentry return -ENOENT
 # #define OBD_FAIL_SRV_ENOENT 0x217
 test_69() {
@@ -6155,6 +6127,11 @@ run_test 77j "client only supporting ADLER32"
 rm -f $F77_TMP
 unset F77_TMP
 
+cleanup_test_78() {
+       trap 0
+       rm -f $DIR/$tfile
+}
+
 test_78() { # bug 10901
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        remote_ost || { skip_env "local OST" && return; }
@@ -6184,6 +6161,8 @@ test_78() { # bug 10901
        [[ $SMALLESTOST -lt 10240 ]] &&
                skip "too small OSTSIZE, useless to run large O_DIRECT test" && return 0
 
+       trap cleanup_test_78 EXIT
+
        [[ $F78SIZE -gt $((SMALLESTOST * $OSTCOUNT / 1024 - 80)) ]] &&
                F78SIZE=$((SMALLESTOST * $OSTCOUNT / 1024 - 80))
 
@@ -6196,7 +6175,7 @@ test_78() { # bug 10901
                $DIRECTIO rdwr $DIR/$tfile 0 $FSIZE 1048576||error "rdwr failed"
        done
 
-       rm -f $DIR/$tfile
+       cleanup_test_78
 }
 run_test 78 "handle large O_DIRECT writes correctly ============"
 
@@ -6678,6 +6657,10 @@ run_test 101e "check read-ahead for small read(1k) for small files(500k)"
 test_101f() {
        which iozone || { skip "no iozone installed" && return; }
 
+       local old_debug=$($LCTL get_param debug)
+       old_debug=${old_debug#*=}
+       $LCTL set_param debug="reada mmap"
+
        # create a test file
        iozone -i 0 -+n -r 1m -s 128m -w -f $DIR/$tfile > /dev/null 2>&1
 
@@ -6688,13 +6671,16 @@ test_101f() {
        $LCTL set_param -n llite.*.read_ahead_stats 0
 
        echo mmap read the file with small block size
-       iozone -i 1 -+n -r 32k -s 128m -B -f $DIR/$tfile > /dev/null 2>&1
+       iozone -i 1 -u 1 -l 1 -+n -r 32k -s 128m -B -f $DIR/$tfile \
+               > /dev/null 2>&1
 
        echo checking missing pages
+       $LCTL get_param llite.*.read_ahead_stats
        local miss=$($LCTL get_param -n llite.*.read_ahead_stats |
                        get_named_value 'misses' | cut -d" " -f1 | calc_total)
 
-       [ $miss -lt 3 ] || error "misses too much pages!"
+       $LCTL set_param debug="$old_debug"
+       [ $miss -lt 3 ] || error "misses too much pages ('$miss')!"
        rm -f $DIR/$tfile
 }
 run_test 101f "check mmap read performance"
@@ -7127,29 +7113,31 @@ getxattr() { # getxattr path name
 }
 
 test_102n() { # LU-4101 mdt: protect internal xattrs
-       local file0=$DIR/$tfile.0
-       local file1=$DIR/$tfile.1
-       local xattr0=$TMP/$tfile.0
-       local xattr1=$TMP/$tfile.1
-       local name
-       local value
-
        [ -z "$(which setfattr 2>/dev/null)" ] &&
                skip "could not find setfattr" && return
-
        if [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.5.50) ]
        then
                skip "MDT < 2.5.50 allows setxattr on internal trusted xattrs"
                return
        fi
 
+       local file0=$DIR/$tfile.0
+       local file1=$DIR/$tfile.1
+       local xattr0=$TMP/$tfile.0
+       local xattr1=$TMP/$tfile.1
+       local namelist="lov lma lmv link fid version som hsm"
+       local name
+       local value
+
        rm -rf $file0 $file1 $xattr0 $xattr1
        touch $file0 $file1
 
        # Get 'before' xattrs of $file1.
        getfattr --absolute-names --dump --match=- $file1 > $xattr0
 
-       for name in lov lma lmv link fid version som hsm; do
+       [ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.8.53) ] &&
+               namelist+=" lfsck_namespace"
+       for name in $namelist; do
                # Try to copy xattr from $file0 to $file1.
                value=$(getxattr $file0 trusted.$name 2> /dev/null)
 
@@ -7286,7 +7274,8 @@ test_103a() {
 
        SAVE_UMASK=$(umask)
        umask 0022
-       cd $DIR
+       mkdir -p $DIR/$tdir
+       cd $DIR/$tdir
 
        echo "performing cp ..."
        run_acl_subtest cp || error "run_acl_subtest cp failed"
@@ -7296,6 +7285,15 @@ test_103a() {
        run_acl_subtest misc || error  "misc test failed"
        echo "performing permissions..."
        run_acl_subtest permissions || error "permissions failed"
+       # LU-1482 mdd: Setting xattr are properly checked with and without ACLs
+       if [ $(lustre_version_code $SINGLEMDS) -gt $(version_code 2.8.55) -o \
+            \( $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.6) -a \
+            $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.5.29) \) ]
+       then
+               echo "performing permissions xattr..."
+               run_acl_subtest permissions_xattr ||
+                       error "permissions_xattr failed"
+       fi
        echo "performing setfacl..."
        run_acl_subtest setfacl || error  "setfacl test failed"
 
@@ -7556,20 +7554,24 @@ run_test 115 "verify dynamic thread creation===================="
 free_min_max () {
        wait_delete_completed
        AVAIL=($(lctl get_param -n osc.*[oO][sS][cC]-[^M]*.kbytesavail))
-       echo OST kbytes available: ${AVAIL[@]}
-       MAXI=0; MAXV=${AVAIL[0]}
-       MINI=0; MINV=${AVAIL[0]}
+       echo "OST kbytes available: ${AVAIL[@]}"
+       MAXV=${AVAIL[0]}
+       MAXI=0
+       MINV=${AVAIL[0]}
+       MINI=0
        for ((i = 0; i < ${#AVAIL[@]}; i++)); do
                #echo OST $i: ${AVAIL[i]}kb
                if [[ ${AVAIL[i]} -gt $MAXV ]]; then
-                       MAXV=${AVAIL[i]}; MAXI=$i
+                       MAXV=${AVAIL[i]}
+                       MAXI=$i
                fi
                if [[ ${AVAIL[i]} -lt $MINV ]]; then
-                       MINV=${AVAIL[i]}; MINI=$i
+                       MINV=${AVAIL[i]}
+                       MINI=$i
                fi
        done
-       echo Min free space: OST $MINI: $MINV
-       echo Max free space: OST $MAXI: $MAXV
+       echo "Min free space: OST $MINI: $MINV"
+       echo "Max free space: OST $MAXI: $MAXV"
 }
 
 test_116a() { # was previously test_116()
@@ -7592,9 +7594,9 @@ test_116a() { # was previously test_116()
 
        # Check if we need to generate uneven OSTs
        test_mkdir -p $DIR/$tdir/OST${MINI}
-       local FILL=$(($MINV / 4))
-       local DIFF=$(($MAXV - $MINV))
-       local DIFF2=$(($DIFF * 100 / $MINV))
+       local FILL=$((MINV / 4))
+       local DIFF=$((MAXV - MINV))
+       local DIFF2=$((DIFF * 100 / MINV))
 
        local threshold=$(do_facet $SINGLEMDS \
                lctl get_param -n *.*MDT0000-mdtlov.qos_threshold_rr | head -n1)
@@ -7608,15 +7610,15 @@ test_116a() { # was previously test_116()
        else
                # generate uneven OSTs. Write 2% over the QOS threshold value
                echo "no"
-               DIFF=$(($threshold - $DIFF2 + 2))
-               DIFF2=$(( ($MINV * $DIFF)/100 ))
-               echo "Fill ${DIFF}% remaining space in OST${MINI} with ${DIFF2}KB"
+               DIFF=$((threshold - DIFF2 + 2))
+               DIFF2=$((MINV * DIFF / 100))
+               echo "Fill $DIFF% remaining space in OST$MINI with ${DIFF2}KB"
                $SETSTRIPE -i $MINI -c 1 $DIR/$tdir/OST${MINI} ||
                        error "setstripe failed"
-               DIFF=$(($DIFF2 / 2048))
+               DIFF=$((DIFF2 / 2048))
                i=0
                while [ $i -lt $DIFF ]; do
-                       i=$(($i + 1))
+                       i=$((i + 1))
                        dd if=/dev/zero of=$DIR/$tdir/OST${MINI}/$tfile-$i \
                                bs=2M count=1 2>/dev/null
                        echo -n .
@@ -7627,10 +7629,10 @@ test_116a() { # was previously test_116()
                free_min_max
        fi
 
-       DIFF=$(($MAXV - $MINV))
-       DIFF2=$(($DIFF * 100 / $MINV))
-       echo -n "diff=${DIFF}=${DIFF2}% must be > ${threshold}% for QOS mode..."
-       if [[ $DIFF2 -gt $threshold ]]; then
+       DIFF=$((MAXV - MINV))
+       DIFF2=$((DIFF * 100 / MINV))
+       echo -n "diff=$DIFF=$DIFF2% must be > $threshold% for QOS mode..."
+       if [ $DIFF2 -gt $threshold ]; then
                echo "ok"
        else
                echo "failed - QOS mode won't be used"
@@ -7639,12 +7641,14 @@ test_116a() { # was previously test_116()
                return
        fi
 
-       MINI1=$MINI; MINV1=$MINV
-       MAXI1=$MAXI; MAXV1=$MAXV
+       MINI1=$MINI
+       MINV1=$MINV
+       MAXI1=$MAXI
+       MAXV1=$MAXV
 
        # now fill using QOS
        $SETSTRIPE -c 1 $DIR/$tdir
-       FILL=$(($FILL / 200))
+       FILL=$((FILL / 200))
        if [ $FILL -gt 600 ]; then
                FILL=600
        fi
@@ -7662,31 +7666,31 @@ test_116a() { # was previously test_116()
 
        echo "Note: free space may not be updated, so measurements might be off"
        free_min_max
-       DIFF2=$(($MAXV - $MINV))
+       DIFF2=$((MAXV - MINV))
        echo "free space delta: orig $DIFF final $DIFF2"
        [ $DIFF2 -gt $DIFF ] && echo "delta got worse!"
-       DIFF=$(($MINV1 - ${AVAIL[$MINI1]}))
+       DIFF=$((MINV1 - ${AVAIL[$MINI1]}))
        echo "Wrote ${DIFF}KB to smaller OST $MINI1"
-       DIFF2=$(($MAXV1 - ${AVAIL[$MAXI1]}))
+       DIFF2=$((MAXV1 - ${AVAIL[$MAXI1]}))
        echo "Wrote ${DIFF2}KB to larger OST $MAXI1"
        if [[ $DIFF -gt 0 ]]; then
-               FILL=$(($DIFF2 * 100 / $DIFF - 100))
+               FILL=$((DIFF2 * 100 / DIFF - 100))
                echo "Wrote ${FILL}% more data to larger OST $MAXI1"
        fi
 
        # Figure out which files were written where
        UUID=$(lctl get_param -n lov.${FSNAME}-clilov-*.target_obd |
-                 awk '/'$MINI1': / {print $2; exit}')
+              awk '/'$MINI1': / {print $2; exit}')
        echo $UUID
        MINC=$($GETSTRIPE --ost $UUID $DIR/$tdir | grep $DIR | wc -l)
        echo "$MINC files created on smaller OST $MINI1"
        UUID=$(lctl get_param -n lov.${FSNAME}-clilov-*.target_obd |
-                 awk '/'$MAXI1': / {print $2; exit}')
+              awk '/'$MAXI1': / {print $2; exit}')
        echo $UUID
        MAXC=$($GETSTRIPE --ost $UUID $DIR/$tdir | grep $DIR | wc -l)
        echo "$MAXC files created on larger OST $MAXI1"
        if [[ $MINC -gt 0 ]]; then
-               FILL=$(($MAXC * 100 / $MINC - 100))
+               FILL=$((MAXC * 100 / MINC - 100))
                echo "Wrote ${FILL}% more files to larger OST $MAXI1"
        fi
        [[ $MAXC -gt $MINC ]] ||
@@ -8331,6 +8335,7 @@ test_120e() {
        stat $DIR/$tdir $DIR/$tdir/f1 > /dev/null
        # XXX client can not do early lock cancel of OST lock
        # during unlink (LU-4206), so cancel osc lock now.
+       sleep 2
        cancel_lru_locks osc
        can1=$(do_facet $SINGLEMDS \
               "$LCTL get_param -n ldlm.services.ldlm_canceld.stats" |
@@ -8373,6 +8378,7 @@ test_120f() {
        stat $DIR/$tdir/d1 $DIR/$tdir/d2 $DIR/$tdir/d1/f1 $DIR/$tdir/d2/f2 > /dev/null
        # XXX client can not do early lock cancel of OST lock
        # during rename (LU-4206), so cancel osc lock now.
+       sleep 2
        cancel_lru_locks osc
        can1=$(do_facet $SINGLEMDS \
               "$LCTL get_param -n ldlm.services.ldlm_canceld.stats" |
@@ -8667,11 +8673,18 @@ test_124b() {
 
        NR=$(($(default_lru_size)*20))
        if [[ $NR -gt $LIMIT ]]; then
-                log "Limit lock number by $LIMIT locks"
-                NR=$LIMIT
-        fi
-        lru_resize_disable mdc
-        test_mkdir -p $DIR/$tdir/disable_lru_resize ||
+               log "Limit lock number by $LIMIT locks"
+               NR=$LIMIT
+       fi
+
+       IFree=$(mdsrate_inodes_available)
+       if [ $IFree -lt $NR ]; then
+               log "Limit lock number by $IFree inodes"
+               NR=$IFree
+       fi
+
+       lru_resize_disable mdc
+       test_mkdir -p $DIR/$tdir/disable_lru_resize ||
                error "failed to create $DIR/$tdir/disable_lru_resize"
 
         createmany -o $DIR/$tdir/disable_lru_resize/f $NR
@@ -10128,20 +10141,43 @@ test_154A() {
        [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.4.1) ]] &&
                skip "Need MDS version at least 2.4.1" && return
 
-       touch $DIR/$tfile
-       local FID=$($LFS path2fid $DIR/$tfile)
-       [ -z "$FID" ] && error "path2fid unable to get $DIR/$tfile FID"
+       local tf=$DIR/$tfile
+       touch $tf
 
-       # check that we get the same pathname back
-       local FOUND=$($LFS fid2path $MOUNT "$FID")
-       [ -z "$FOUND" ] && error "fid2path unable to get $FID path"
-       [ "$FOUND" != "$DIR/$tfile" ] &&
-               error "fid2path(path2fid($DIR/$tfile)) = $FOUND != $DIR/$tfile"
+       local fid=$($LFS path2fid $tf)
+       [ -z "$fid" ] && error "path2fid unable to get $tf FID"
 
-       rm -rf $DIR/$tfile
+       # check that we get the same pathname back
+       local found=$($LFS fid2path $MOUNT "$fid")
+       [ -z "$found" ] && error "fid2path unable to get '$fid' path"
+       [ "$found" == "$tf" ] ||
+               error "fid2path($fid=path2fid($tf)) = $found != $tf"
 }
 run_test 154A "lfs path2fid and fid2path basic checks"
 
+test_154B() {
+       [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.4.1) ]] &&
+               skip "Need MDS version at least 2.4.1" && return
+
+       mkdir -p $DIR/$tdir || error "mkdir $tdir failed"
+       touch $DIR/$tdir/$tfile || error "touch $DIR/$tdir/$tfile failed"
+       local linkea=$($LL_DECODE_LINKEA $DIR/$tdir/$tfile | grep 'pfid')
+       [ -z "$linkea" ] && error "decode linkea $DIR/$tdir/$tfile failed"
+
+       local name=$(echo $linkea | awk '/pfid/ {print $5}' | sed -e "s/'//g")
+       local PFID=$(echo $linkea | awk '/pfid/ {print $3}' | sed -e "s/,//g")
+
+       # check that we get the same pathname
+       echo "PFID: $PFID, name: $name"
+       local FOUND=$($LFS fid2path $MOUNT "$PFID")
+       [ -z "$FOUND" ] && error "fid2path unable to get $PFID path"
+       [ "$FOUND/$name" != "$DIR/$tdir/$tfile" ] &&
+               error "ll_decode_linkea has $FOUND/$name != $DIR/$tdir/$tfile"
+
+       rm -rf $DIR/$tdir || error "Can not delete directory $DIR/$tdir"
+}
+run_test 154B "verify the ll_decode_linkea tool"
+
 test_154a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        [[ $(lustre_version_code $SINGLEMDS) -ge $(version_code 2.2.51) ]] ||
@@ -10416,67 +10452,114 @@ test_155_big_load() {
     true
 }
 
+save_writethrough() {
+       local facets=$(get_facets OST)
+
+       save_lustre_params $facets "obdfilter.*.writethrough_cache_enable" > $1
+       save_lustre_params $facets "osd-*.*.writethrough_cache_enable" >> $1
+}
+
 test_155a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
+       save_writethrough $p
+
        set_cache read on
        set_cache writethrough on
        test_155_small_load
+       restore_lustre_params < $p
+       rm -f $p
 }
 run_test 155a "Verify small file correctness: read cache:on write_cache:on"
 
 test_155b() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
+       save_writethrough $p
+
        set_cache read on
        set_cache writethrough off
        test_155_small_load
+       restore_lustre_params < $p
+       rm -f $p
 }
 run_test 155b "Verify small file correctness: read cache:on write_cache:off"
 
 test_155c() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
+       save_writethrough $p
+
        set_cache read off
        set_cache writethrough on
        test_155_small_load
+       restore_lustre_params < $p
+       rm -f $p
 }
 run_test 155c "Verify small file correctness: read cache:off write_cache:on"
 
 test_155d() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
+       save_writethrough $p
+
        set_cache read off
        set_cache writethrough off
        test_155_small_load
+       restore_lustre_params < $p
+       rm -f $p
 }
 run_test 155d "Verify small file correctness: read cache:off write_cache:off"
 
 test_155e() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
+       save_writethrough $p
+
        set_cache read on
        set_cache writethrough on
        test_155_big_load
+       restore_lustre_params < $p
+       rm -f $p
 }
 run_test 155e "Verify big file correctness: read cache:on write_cache:on"
 
 test_155f() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
+       save_writethrough $p
+
        set_cache read on
        set_cache writethrough off
        test_155_big_load
+       restore_lustre_params < $p
+       rm -f $p
 }
 run_test 155f "Verify big file correctness: read cache:on write_cache:off"
 
 test_155g() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
+       save_writethrough $p
+
        set_cache read off
        set_cache writethrough on
        test_155_big_load
+       restore_lustre_params < $p
+       rm -f $p
 }
 run_test 155g "Verify big file correctness: read cache:off write_cache:on"
 
 test_155h() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
+       save_writethrough $p
+
        set_cache read off
        set_cache writethrough off
        test_155_big_load
+       restore_lustre_params < $p
+       rm -f $p
 }
 run_test 155h "Verify big file correctness: read cache:off write_cache:off"
 
@@ -10487,12 +10570,14 @@ test_156() {
        local BEFORE
        local AFTER
        local file="$DIR/$tfile"
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
 
        [ "$(facet_fstype ost1)" = "zfs" -a \
           $(lustre_version_code ost1 -lt $(version_code 2.6.93)) ] &&
                skip "LU-1956/LU-2261: stats not implemented on OSD ZFS" &&
                return
 
+       save_writethrough $p
        roc_hit_init
 
        log "Turn on read and write cache"
@@ -10621,6 +10706,8 @@ test_156() {
        fi
 
        rm -f $file
+       restore_lustre_params < $p
+       rm -f $p
 }
 run_test 156 "Verification of tunables"
 
@@ -10858,6 +10945,36 @@ test_160d() {
 }
 run_test 160d "verify that changelog log catch the migrate event"
 
+test_160e() {
+       # Create a user
+       CL_USER=$(do_facet $SINGLEMDS $LCTL --device $MDT0 \
+               changelog_register -n)
+       echo "Registered as changelog user $CL_USER"
+       trap cleanup_changelog EXIT
+
+       # Delete a future user (expect fail)
+       do_facet $SINGLEMDS $LCTL --device $MDT0 changelog_deregister cl77
+       local rc=$?
+
+       if [ $rc -eq 0 ]; then
+               error "Deleted non-existant user cl77"
+       elif [ $rc -ne 2 ]; then
+               error "changelog_deregister failed with $rc, " \
+                       "expected 2 (ENOENT)"
+       fi
+
+       # Clear to a bad index (1 billion should be safe)
+       $LFS changelog_clear $MDT0 $CL_USER 1000000000
+       rc=$?
+
+       if [ $rc -eq 0 ]; then
+               error "Successfully cleared to invalid CL index"
+       elif [ $rc -ne 22 ]; then
+               error "changelog_clear failed with $rc, expected 22 (EINVAL)"
+       fi
+}
+run_test 160e "changelog negative testing"
+
 test_161a() {
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        test_mkdir -p -c1 $DIR/$tdir
@@ -12023,8 +12140,10 @@ test_205() { # Job stats
        cmd="mv -f $DIR/$tfile $DIR/$tdir.rename"
        verify_jobstats "$cmd" "$SINGLEMDS"
        # jobstats expiry - sleep until old stats should be expired
-       local left=$((interval_new + 2 - (SECONDS - start)))
-       [ $left -ge 0 ] && echo "sleep $left for expiry" && sleep $((left + 1))
+       local left=$((interval_new + 5 - (SECONDS - start)))
+       [ $left -ge 0 ] && wait_update_facet $SINGLEMDS \
+               "lctl get_param *.*.job_stats | grep -c 'job_id.*mkdir'" \
+                       "0" $left
        cmd="mkdir $DIR/$tdir.expire"
        verify_jobstats "$cmd" "$SINGLEMDS"
        [ $(do_facet $SINGLEMDS lctl get_param *.*.job_stats |
@@ -12573,6 +12692,11 @@ run_test 224b "Don't panic on bulk IO failure"
 test_224c() { # LU-6441
        [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
        remote_mds_nodsh && skip "remote MDS with nodsh" && return
+
+       local p="$TMP/$TESTSUITE-$TESTNAME.parameters"
+       save_writethrough $p
+       set_cache writethrough on
+
        local pages_per_rpc=$($LCTL get_param \
                                osc.*.max_pages_per_rpc)
        local at_max=$($LCTL get_param -n at_max)
@@ -12590,10 +12714,11 @@ test_224c() { # LU-6441
                error "conf_param timeout=5 failed"
 
        #define OBD_FAIL_PTLRPC_CLIENT_BULK_CB3   0x520
-       $LCTL set_param fail_loc=0x520
+       do_facet ost1 $LCTL set_param fail_loc=0x520
+       $LFS setstripe -c 1 -i 0 $DIR/$tfile
        dd if=/dev/zero of=$DIR/$tfile bs=8MB count=1
        sync
-       $LCTL set_param fail_loc=0
+       do_facet ost1 $LCTL set_param fail_loc=0
 
        set_conf_param_and_check client "$test_at" "$param_at" $at_max ||
                error "conf_param at_max=$at_max failed"
@@ -12601,6 +12726,8 @@ test_224c() { # LU-6441
                $timeout || error "conf_param timeout=$timeout failed"
 
        $LCTL set_param -n $pages_per_rpc
+       restore_lustre_params < $p
+       rm -f $p
 }
 run_test 224c "Don't hang if one of md lost during large bulk RPC"
 
@@ -13618,7 +13745,7 @@ test_241_dio() {
        done
 }
 
-test_241() {
+test_241a() { # was test_241
        dd if=/dev/zero of=$DIR/$tfile count=1 bs=40960
        ls -la $DIR/$tfile
        cancel_lru_locks osc
@@ -13627,7 +13754,7 @@ test_241() {
        test_241_dio 1000
        wait $PID
 }
-run_test 241 "bio vs dio"
+run_test 241a "bio vs dio"
 
 test_241b() {
        dd if=/dev/zero of=$DIR/$tfile count=1 bs=40960
@@ -13794,18 +13921,9 @@ test_247e() {
 run_test 247e "mount .. as fileset"
 
 test_248() {
-       local my_error=error
-
        local fast_read_sav=$($LCTL get_param -n llite.*.fast_read 2>/dev/null)
        [ -z "$fast_read_sav" ] && skip "no fast read support" && return
 
-       # This test case is time sensitive and Maloo uses KVM to run autotest.
-       # Therefore the complete time of I/O task is unreliable and depends on
-       # the workload on the host machine when the task is running.
-       local virt=$(running_in_vm)
-       [ -n "$virt" ] && echo "running in VM '$virt', ignore error" &&
-                 my_error="error_ignore env=$virt"
-
        # create a large file for fast read verification
        dd if=/dev/zero of=$DIR/$tfile bs=1M count=128 > /dev/null 2>&1
 
@@ -13827,7 +13945,8 @@ test_248() {
 
        # verify that fast read is 4 times faster for cache read
        [ $(bc <<< "4 * $t_fast < $t_slow") -eq 1 ] ||
-               $my_error "fast read was not 4 times faster: $t_fast vs $t_slow"
+               error_not_in_vm "fast read was not 4 times faster: " \
+                          "$t_fast vs $t_slow"
 
        echo "Test 2: verify the performance between big and small read"
        $LCTL set_param -n llite.*.fast_read=1
@@ -13844,7 +13963,7 @@ test_248() {
 
        # verify that big IO is not 4 times faster than small IO
        [ $(bc <<< "4 * $t_1k >= $t_1m") -eq 1 ] ||
-               $my_error "bigger IO is way too fast: $t_1k vs $t_1m"
+               error_not_in_vm "bigger IO is way too fast: $t_1k vs $t_1m"
 
        $LCTL set_param -n llite.*.fast_read=$fast_read_sav
        rm -f $DIR/$tfile
@@ -13948,6 +14067,129 @@ test_252() {
 }
 run_test 252 "check lr_reader tool"
 
+test_253_fill_ost() {
+       local size_mb #how many MB should we write to pass watermark
+       local lwm=$3  #low watermark
+       local free_10mb #10% of free space
+
+       free_kb=$($LFS df $MOUNT | grep $1 | awk '{ print $4 }')
+       size_mb=$((free_kb / 1024 - lwm))
+       free_10mb=$((free_kb / 10240))
+       #If 10% of free space cross low watermark use it
+       if (( free_10mb > size_mb )); then
+               size_mb=$free_10mb
+       else
+               #At least we need to store 1.1 of difference between
+               #free space and low watermark
+               size_mb=$((size_mb + size_mb / 10))
+       fi
+       if (( lwm <= $((free_kb / 1024)) )) || [ ! -f $DIR/$tdir/1 ]; then
+               dd if=/dev/zero of=$DIR/$tdir/1 bs=1M count=$size_mb \
+                        oflag=append conv=notrunc
+       fi
+
+       sleep_maxage
+
+       free_kb=$($LFS df $MOUNT | grep $1 | awk '{ print $4 }')
+       echo "OST still has $((free_kb / 1024)) mbytes free"
+}
+
+test_253() {
+       local ostidx=0
+       local rc=0
+
+       [ $PARALLEL == "yes" ] && skip "skip parallel run" && return
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
+       remote_mgs_nodsh && skip "remote MGS with nodsh" && return
+
+       local ost_name=$($LFS osts |
+               sed -n 's/^'$ostidx': \(.*\)_UUID .*/\1/p')
+       # on the mdt's osc
+       local mdtosc_proc1=$(get_mdtosc_proc_path $SINGLEMDS $ost_name)
+       do_facet $SINGLEMDS $LCTL get_param -n \
+               osp.$mdtosc_proc1.reserved_mb_high ||
+               { skip  "remote MDS does not support reserved_mb_high" &&
+                 return; }
+
+       rm -rf $DIR/$tdir
+       wait_mds_ost_sync
+       wait_delete_completed
+       mkdir $DIR/$tdir
+
+       local last_wm_h=$(do_facet $SINGLEMDS $LCTL get_param -n \
+                       osp.$mdtosc_proc1.reserved_mb_high)
+       local last_wm_l=$(do_facet $SINGLEMDS $LCTL get_param -n \
+                       osp.$mdtosc_proc1.reserved_mb_low)
+       echo "prev high watermark $last_wm_h, prev low watermark $last_wm_l"
+
+       do_facet mgs $LCTL pool_new $FSNAME.$TESTNAME ||
+               error "Pool creation failed"
+       do_facet mgs $LCTL pool_add $FSNAME.$TESTNAME $ost_name ||
+               error "Adding $ost_name to pool failed"
+
+       # Wait for client to see a OST at pool
+       wait_update $HOSTNAME "$LCTL get_param -n
+               lov.$FSNAME-*.pools.$TESTNAME | sort -u |
+               grep $ost_name" "$ost_name""_UUID" $((TIMEOUT/2)) ||
+               error "Client can not see the pool"
+       $SETSTRIPE $DIR/$tdir -i $ostidx -c 1 -p $FSNAME.$TESTNAME ||
+               error "Setstripe failed"
+
+       dd if=/dev/zero of=$DIR/$tdir/0 bs=1M count=10
+       local blocks=$($LFS df $MOUNT | grep $ost_name | awk '{ print $4 }')
+       echo "OST still has $((blocks/1024)) mbytes free"
+
+       local new_lwm=$((blocks/1024-10))
+       do_facet $SINGLEMDS $LCTL set_param \
+                       osp.$mdtosc_proc1.reserved_mb_high=$((new_lwm+5))
+       do_facet $SINGLEMDS $LCTL set_param \
+                       osp.$mdtosc_proc1.reserved_mb_low=$new_lwm
+
+       test_253_fill_ost $ost_name $mdtosc_proc1 $new_lwm
+
+       #First enospc could execute orphan deletion so repeat.
+       test_253_fill_ost $ost_name $mdtosc_proc1 $new_lwm
+
+       local oa_status=$(do_facet $SINGLEMDS $LCTL get_param -n \
+                       osp.$mdtosc_proc1.prealloc_status)
+       echo "prealloc_status $oa_status"
+
+       dd if=/dev/zero of=$DIR/$tdir/2 bs=1M count=1 &&
+               error "File creation should fail"
+       #object allocation was stopped, but we still able to append files
+       dd if=/dev/zero of=$DIR/$tdir/1 bs=1M seek=6 count=5 oflag=append ||
+               error "Append failed"
+       rm -f $DIR/$tdir/1 $DIR/$tdir/0 $DIR/$tdir/r*
+
+       wait_delete_completed
+
+       sleep_maxage
+
+       for i in $(seq 10 12); do
+               dd if=/dev/zero of=$DIR/$tdir/$i bs=1M count=1 2>/dev/null ||
+                       error "File creation failed after rm";
+       done
+
+       oa_status=$(do_facet $SINGLEMDS $LCTL get_param -n \
+                       osp.$mdtosc_proc1.prealloc_status)
+       echo "prealloc_status $oa_status"
+
+       if (( oa_status != 0 )); then
+               error "Object allocation still disable after rm"
+       fi
+       do_facet $SINGLEMDS $LCTL set_param \
+                       osp.$mdtosc_proc1.reserved_mb_high=$last_wm_h
+       do_facet $SINGLEMDS $LCTL set_param \
+                       osp.$mdtosc_proc1.reserved_mb_low=$last_wm_l
+
+
+       do_facet mgs $LCTL pool_remove $FSNAME.$TESTNAME $ost_name ||
+               error "Remove $ost_name from pool failed"
+       do_facet mgs $LCTL pool_destroy $FSNAME.$TESTNAME ||
+               error "Pool destroy fialed"
+}
+run_test 253 "Check object allocation limit"
+
 test_254() {
        local cl_user
 
@@ -14024,6 +14266,7 @@ ladvise_willread_performance()
        local repeat=10
        local average_cache=0
        local average_ladvise=0
+
        for ((i = 1; i <= $repeat; i++)); do
                echo "Iter $i/$repeat: reading without willread hint"
                cancel_lru_locks osc
@@ -14073,8 +14316,8 @@ ladvise_willread_performance()
 
        local lowest_speedup=$((average_cache / 2))
        [ $average_ladvise -gt $lowest_speedup ] ||
-               error "Speedup with willread is less than $lowest_speedup%,"\
-                       "got $average_ladvise%"
+               error_not_in_vm "Speedup with willread is less than " \
+                          "$lowest_speedup%, got $average_ladvise%"
        echo "Speedup with willread ladvise: $average_ladvise%"
        echo "Speedup with cache: $average_cache%"
 }
@@ -14158,6 +14401,71 @@ test_255a() {
 }
 run_test 255a "check 'lfs ladvise -a willread'"
 
+facet_meminfo() {
+       local facet=$1
+       local info=$2
+
+       do_facet $facet "cat /proc/meminfo | grep ^${info}:" | awk '{print $2}'
+}
+
+test_255b() {
+       ladvise_no_type dontneed $DIR/$tfile &&
+               skip "dontneed ladvise is not supported" && return
+
+       ladvise_no_ioctl $DIR/$tfile &&
+               skip "ladvise ioctl is not supported" && return
+
+       [ $(lustre_version_code ost1) -lt $(version_code 2.8.54) ] &&
+               skip "lustre < 2.8.54 does not support ladvise" && return
+
+       [ "$(facet_fstype ost1)" = "zfs" ] &&
+               skip "zfs-osd does not support dontneed advice" && return
+
+       lfs setstripe -c 1 -i 0 $DIR/$tfile
+
+       local size_mb=100
+       local size=$((size_mb * 1048576))
+       # In order to prevent disturbance of other processes, only check 3/4
+       # of the memory usage
+       local kibibytes=$((size_mb * 1024 * 3 / 4))
+
+       dd if=/dev/zero of=$DIR/$tfile bs=1048576 count=$size_mb ||
+               error "dd to $DIR/$tfile failed"
+
+       local total=$(facet_meminfo ost1 MemTotal)
+       echo "Total memory: $total KiB"
+
+       do_facet ost1 "sync && echo 3 > /proc/sys/vm/drop_caches"
+       local before_read=$(facet_meminfo ost1 Cached)
+       echo "Cache used before read: $before_read KiB"
+
+       lfs ladvise -a willread $DIR/$tfile ||
+               error "Ladvise willread failed"
+       local after_read=$(facet_meminfo ost1 Cached)
+       echo "Cache used after read: $after_read KiB"
+
+       lfs ladvise -a dontneed $DIR/$tfile ||
+               error "Ladvise dontneed again failed"
+       local no_read=$(facet_meminfo ost1 Cached)
+       echo "Cache used after dontneed ladvise: $no_read KiB"
+
+       if [ $total -lt $((before_read + kibibytes)) ]; then
+               echo "Memory is too small, abort checking"
+               return 0
+       fi
+
+       if [ $((before_read + kibibytes)) -gt $after_read ]; then
+               error "Ladvise willread should use more memory" \
+                       "than $kibibytes KiB"
+       fi
+
+       if [ $((no_read + kibibytes)) -gt $after_read ]; then
+               error "Ladvise dontneed should release more memory" \
+                       "than $kibibytes KiB"
+       fi
+}
+run_test 255b "check 'lfs ladvise -a dontneed'"
+
 test_256() {
        local cl_user
        local cat_sl
@@ -14222,6 +14530,29 @@ test_256() {
 }
 run_test 256 "Check llog delete for empty and not full state"
 
+test_257() {
+       remote_mds_nodsh && skip "remote MDS with nodsh" && return
+       [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.8.55) ]] &&
+               skip "Need MDS version at least 2.8.55" && return
+
+       test_mkdir -p $DIR/$tdir
+
+       setfattr -n trusted.name1 -v value1 $DIR/$tdir ||
+               error "setfattr -n trusted.name1=value1 $DIR/$tdir failed"
+       stat $DIR/$tdir
+
+#define OBD_FAIL_MDS_XATTR_REP                 0x161
+       local mdtidx=$($LFS getstripe -M $DIR/$tdir)
+       local facet=mds$((mdtidx + 1))
+       set_nodes_failloc $(facet_active_host $facet) 0x80000161
+       getfattr -n trusted.name1 $DIR/$tdir 2> /dev/null
+
+       stop $facet || error "stop MDS failed"
+       start $facet $(mdsdevname $((mdtidx + 1))) $MDS_MOUNT_OPTS ||
+               error "start MDS fail"
+}
+run_test 257 "xattr locks are not lost"
+
 test_260() {
 #define OBD_FAIL_MDC_CLOSE               0x806
        $LCTL set_param fail_loc=0x80000806
@@ -14545,6 +14876,24 @@ test_300g() {
        mkdir $DIR/$tdir
        mkdir $DIR/$tdir/normal_dir
 
+       #Checking when client cache stripe index
+       $LFS setdirstripe -c$MDSCOUNT $DIR/$tdir/striped_dir
+       $LFS setdirstripe -D -i1 $DIR/$tdir/striped_dir ||
+               error "create striped_dir failed"
+
+       mkdir $DIR/$tdir/striped_dir/dir1 ||
+               error "create dir1 fails"
+       stripe_index=$($LFS getdirstripe -i $DIR/$tdir/striped_dir/dir1)
+       [ $stripe_index -eq 1 ] ||
+               error "dir1 expect 1 got $stripe_index"
+
+       $LFS setdirstripe -i2 $DIR/$tdir/striped_dir/dir2 ||
+               error "create dir2 fails"
+       stripe_index=$($LFS getdirstripe -i $DIR/$tdir/striped_dir/dir2)
+       [ $stripe_index -eq 2 ] ||
+               error "dir2 expect 2 got $stripe_index"
+
+       #check default stripe count/stripe index
        test_300_check_default_striped_dir normal_dir $MDSCOUNT 1
        test_300_check_default_striped_dir normal_dir 1 0
        test_300_check_default_striped_dir normal_dir 2 1
@@ -14987,12 +15336,14 @@ test_311() {
        local new_iused
        for i in $(seq 120); do
                new_iused=$($LFS df -i | grep OST0000 | awk '{ print $3 }')
-               [ $new_iused -lt $((old_iused - 900)) ] && break
+               # system may be too busy to destroy all objs in time, use
+               # a somewhat small value to not fail autotest
+               [ $((old_iused - new_iused)) -gt 400 ] && break
                sleep 1
        done
 
        echo "waited $i sec, old Iused $old_iused, new Iused $new_iused"
-       [ $new_iused -lt $((old_iused - 900)) ] ||
+       [ $((old_iused - new_iused)) -gt 400 ] ||
                error "objs not destroyed after unlink"
 }
 run_test 311 "disable OSP precreate, and unlink should destroy objs"
@@ -15095,6 +15446,92 @@ test_312() { # LU-4856
 }
 run_test 312 "make sure ZFS adjusts its block size by write pattern"
 
+test_313() {
+       local file=$DIR/$tfile
+       rm -f $file
+       $SETSTRIPE -c 1 -i 0 $file || error "setstripe failed"
+
+       # define OBD_FAIL_TGT_RCVD_EIO           0x720
+       do_facet ost1 "$LCTL set_param fail_loc=0x720"
+       dd if=/dev/zero of=$file bs=4096 oflag=direct count=1 &&
+               error "write should failed"
+       do_facet ost1 "$LCTL set_param fail_loc=0"
+       rm -f $file
+}
+run_test 313 "io should fail after last_rcvd update fail"
+
+test_fake_rw() {
+       local read_write=$1
+       if [ "$read_write" = "write" ]; then
+               local dd_cmd="dd if=/dev/zero of=$DIR/$tfile"
+       elif [ "$read_write" = "read" ]; then
+               local dd_cmd="dd of=/dev/null if=$DIR/$tfile"
+       else
+               error "argument error"
+       fi
+
+       # turn off debug for performance testing
+       local saved_debug=$($LCTL get_param -n debug)
+       $LCTL set_param debug=0
+
+       $SETSTRIPE -c 1 -i 0 $DIR/$tfile
+
+       # get ost1 size - lustre-OST0000
+       local ost1_avail_size=$($LFS df | awk /${ost1_svc}/'{ print $4 }')
+       local blocks=$((ost1_avail_size/2/1024)) # half avail space by megabytes
+       [ $blocks -gt 1000 ] && blocks=1000 # 1G in maximum
+
+       if [ "$read_write" = "read" ]; then
+               truncate -s $(expr 1048576 \* $blocks) $DIR/$tfile
+       fi
+
+       local start_time=$(date +%s.%N)
+       $dd_cmd bs=1M count=$blocks oflag=sync ||
+               error "real dd $read_write error"
+       local duration=$(bc <<< "$(date +%s.%N) - $start_time")
+
+       if [ "$read_write" = "write" ]; then
+               rm -f $DIR/$tfile
+       fi
+
+       # define OBD_FAIL_OST_FAKE_RW           0x238
+       do_facet ost1 $LCTL set_param fail_loc=0x238
+
+       local start_time=$(date +%s.%N)
+       $dd_cmd bs=1M count=$blocks oflag=sync ||
+               error "fake dd $read_write error"
+       local duration_fake=$(bc <<< "$(date +%s.%N) - $start_time")
+
+       if [ "$read_write" = "write" ]; then
+               # verify file size
+               cancel_lru_locks osc
+               $CHECKSTAT -t file -s $((blocks * 1024 * 1024)) $DIR/$tfile ||
+                       error "$tfile size not $blocks MB"
+       fi
+       do_facet ost1 $LCTL set_param fail_loc=0
+
+       echo "fake $read_write $duration_fake vs. normal $read_write" \
+               "$duration in seconds"
+       [ $(bc <<< "$duration_fake < $duration") -eq 1 ] ||
+               error_not_in_vm "fake write is slower"
+
+       $LCTL set_param -n debug="$saved_debug"
+       rm -f $DIR/$tfile
+}
+test_399a() { # LU-7655 for OST fake write
+       test_fake_rw write
+}
+run_test 399a "fake write should not be slower than normal write"
+
+
+test_399b() { # LU-8726 for OST fake read
+       if [ "$(facet_fstype ost1)" != "ldiskfs" ]; then
+               skip "only for ldiskfs" && return 0
+       fi
+       test_fake_rw read
+}
+run_test 399b "fake read should not be slower than normal read"
+
 test_400a() { # LU-1606, was conf-sanity test_74
        local extra_flags=''
        local out=$TMP/$tfile
@@ -15247,6 +15684,14 @@ test_401d() {
 run_test 401d "Verify 'lctl set_param' accepts values containing '='"
 
 test_402() {
+       local server_version=$(lustre_version_code $SINGLEMDS)
+       [[ $server_version -ge $(version_code 2.7.66) ]] ||
+       [[ $server_version -ge $(version_code 2.7.18.4) &&
+               $server_version -lt $(version_code 2.7.50) ]] ||
+       [[ $server_version -ge $(version_code 2.7.2) &&
+               $server_version -lt $(version_code 2.7.11) ]] ||
+               { skip "Need MDS version 2.7.2+ or 2.7.18.4+ or 2.7.66+";
+                       return; }
        remote_mds_nodsh && skip "remote MDS with nodsh" && return
        $LFS setdirstripe -i 0 $DIR/$tdir || error "setdirstripe -i 0 failed"
 #define OBD_FAIL_MDS_FLD_LOOKUP 0x15c
@@ -15402,6 +15847,81 @@ test_406() {
 }
 run_test 406 "DNE support fs default striping"
 
+test_407() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       [[ $(lustre_version_code $SINGLEMDS) -lt $(version_code 2.8.55) ]] &&
+               skip "Need MDS version at least 2.8.55" && return
+
+       $LFS mkdir -i 0 -c 1 $DIR/$tdir.0 ||
+               error "$LFS mkdir -i 0 -c 1 $tdir.0 failed"
+       $LFS mkdir -i 1 -c 1 $DIR/$tdir.1 ||
+               error "$LFS mkdir -i 1 -c 1 $tdir.1 failed"
+       touch $DIR/$tdir.0/$tfile.0 || error "touch $tdir.0/$tfile.0 failed"
+
+       #define OBD_FAIL_DT_TXN_STOP    0x2019
+       for idx in $(seq $MDSCOUNT); do
+               do_facet mds$idx "lctl set_param fail_loc=0x2019"
+       done
+       $LFS mkdir -c 2 $DIR/$tdir && error "$LFS mkdir -c 2 $tdir should fail"
+       mv $DIR/$tdir.0/$tfile.0 $DIR/$tdir.1/$tfile.1 &&
+               error "mv $tdir.0/$tfile.0 $tdir.1/$tfile.1 should fail"
+       true
+}
+run_test 407 "transaction fail should cause operation fail"
+
+test_408() {
+       dd if=/dev/zero of=$DIR/$tfile bs=4096 count=1 oflag=direct
+
+       #define OBD_FAIL_OSC_BRW_PREP_REQ2        0x40a
+       lctl set_param fail_loc=0x8000040a
+       # let ll_prepare_partial_page() fail
+       dd if=/dev/zero of=$DIR/$tfile bs=2048 count=1 conv=notrunc || true
+
+       rm -f $DIR/$tfile
+
+       # create at least 100 unused inodes so that
+       # shrink_icache_memory(0) should not return 0
+       touch $DIR/$tfile-{0..100}
+       rm -f $DIR/$tfile-{0..100}
+       sync
+
+       echo 2 > /proc/sys/vm/drop_caches
+}
+run_test 408 "drop_caches should not hang due to page leaks"
+
+test_409()
+{
+       [ $MDSCOUNT -lt 2 ] &&
+               skip "We need at least 2 MDTs for this test" && return
+
+       check_mount_and_prep
+
+       mkdir -p $DIR/$tdir || error "(0) Fail to mkdir"
+       $LFS mkdir -i 1 -c 2 $DIR/$tdir/foo || error "(1) Fail to mkdir"
+       touch $DIR/$tdir/guard || error "(2) Fail to create"
+
+       local PREFIX=$(str_repeat 'A' 128)
+       echo "Create 1K hard links start at $(date)"
+       createmany -l $DIR/$tdir/guard $DIR/$tdir/foo/${PREFIX}_ 1000 ||
+               error "(3) Fail to hard link"
+
+       echo "Links count should be right although linkEA overflow"
+       stat $DIR/$tdir/guard || error "(4) Fail to stat"
+       local linkcount=$(stat --format=%h $DIR/$tdir/guard)
+       [ $linkcount -eq 1001 ] ||
+               error "(5) Unexpected hard links count: $linkcount"
+
+       echo "List all links start at $(date)"
+       ls -l $DIR/$tdir/foo > /dev/null ||
+               error "(6) Fail to list $DIR/$tdir/foo"
+
+       echo "Unlink hard links start at $(date)"
+       unlinkmany $DIR/$tdir/foo/${PREFIX}_ 1000 ||
+               error "(7) Fail to unlink"
+}
+run_test 409 "Large amount of cross-MDTs hard links on the same file"
+
 #
 # tests that do cleanup/setup should be run at the end
 #